<script lang="ts">
  import { getBulls } from "./domain";
  import Bullhead from "./Bullhead.svelte";

  export let card: Card;
  export let faceDown: boolean = false;
</script>

<div class="outer points-{getBulls(card)}" class:face-down={faceDown}>
  <div class="inner">
    {#if !faceDown}
      <div class="top-text">
        <span>
          {card}
        </span>
        <span class="bullheads">
          <Bullhead />
          <span class="times">&times;</span>
          {getBulls(card)}
        </span>
      </div>
      <div class="center-text">
        {card}
      </div>
      <div class="bottom-text">
        {card}
      </div>
    {:else}
      <div class="back-icon"><Bullhead /></div>
    {/if}
  </div>
</div>

<style>
  .outer {
    font-family: "Londrina Solid", cursive;
    font-weight: 300;

    width: 5em;
    height: 7em;
    background-color: rgb(255, 253, 250);
    box-shadow: 0.1em 0.1em 0.1em -0.02em #11111122;

    position: relative;

    border: #aaa7 solid 0.01em;
    border-radius: 7% / 5%;
  }

  .points-1 {
    color: var(--gs6-bullheaded-purple);
  }
  .points-2 {
    color: hsl(190, 50%, 40%);
  }
  .points-3 {
    color: hsl(100, 50%, 40%);
  }
  .points-5 {
    color: hsl(0, 50%, 50%);
  }
  .points-7 {
    color: hsl(300, 40%, 50%);
  }

  .times {
    font-weight: bolder;
    font-family: sans-serif;
  }

  .face-down .inner {
    background-image: url("../assets/noise.png");
    background-repeat: repeat;
    background-color: hsl(240, 33%, 55%);
  }
  .face-down .inner::after {
    content: "";
    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    background: radial-gradient(transparent 25%, hsl(240, 33%, 40%) 100%);
  }

  .inner {
    background-color: linen;
    position: absolute;
    top: 0.25em;
    bottom: 0.25em;
    left: 0.25em;
    right: 0.25em;

    border: 0.05em solid #99999933;
    border-radius: 3.5% / 2.5%;
  }

  .top-text,
  .bottom-text {
    font-size: 0.9em;
  }

  .top-text {
    position: absolute;

    top: -0.125em;
    left: 0;
    right: 0;

    display: flex;
    justify-content: space-between;
    align-items: center;
  }

  .center-text {
    font-size: 225%;

    position: absolute;
    top: 0;
    left: 0;
    right: 0;
    bottom: 0;
    display: grid;
    place-content: center;
  }

  .back-icon {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) scale(2.5) rotate(12deg);
    filter: brightness(0) blur(0.01em) opacity(0.4);
  }

  .bottom-text {
    position: absolute;

    bottom: -0.125em;
    right: 0;
  }

  .bullheads {
    font-size: 75%;
  }
</style>
